<?php
	require_once("includes/header.inc");

	// send the user to choose.php if he did not choose a photo as a reference
	if (!isset($_GET['id'])) {
		header('Location: choose.php');
		return;
	} else {
		$id = $_GET['id'];
	}

	if (isset($_GET['color']))
		$color = $_GET['color'];
	else
		$color = 0.5;
	
	if (isset($_GET['shape']))
		$shape = $_GET['shape'];
	else
		$shape = 0.5;
	
	if (isset($_GET['texture']))
		$texture = $_GET['texture'];
	else
		$texture = 0.5;

	if (isset($_GET['location']))
		$location = $_GET['location'];
	else
		$location = 0.5;
	
	if (isset($_GET['threshold']))
		$threshold = $_GET['threshold'];
	else
		$threshold = 100;
	
	// check if the necessary tables exist
	preparePhotosTable($db);
;
	if (setDecimalPoint($db)) {
		$messages[] = "Altered session successfully.";
	} else {
		$messages[] = "Unable to specify a new decimal point.<br />This page will probably not work as expected.";
	}

	if (!isset($_GET['skip']))
		$skip = 0;
	else 
		$skip = $_GET['skip'];

	$innerSQL = "SELECT ROW_NUMBER() OVER (ORDER BY score ASC) AS rn, id, score FROM ( 
				SELECT Q.id, ORDSYS.IMGScore(123) score
				FROM $strCbrTable Q, $strCbrTable E
				WHERE E.id=$id AND Q.id != E.id
					AND ORDSYS.IMGSimilar(Q.image_sig, E.image_sig, 'color=\"$color\" location=\"$location\"
					shape=\"$shape\" texture=\"$texture\"', $threshold, 123)=1
				ORDER BY score ASC
			)";
	
	// comment on this ...
	$sql = "SELECT * FROM (
			$innerSQL
		)
		WHERE rn > $skip AND rn <= ($numberOfPhotosOnPage + $skip)";

	executeQuery($db, $sql, &$header1, &$matchedImages);

	$sql = "SELECT count(*) as count FROM (
			$innerSQL
		)";
	
	executeQuery($db, $sql, &$header2, &$countArray);
	
	// if there are no images in the database we will print a
	// message to let the user know
	$count = $countArray[0]["COUNT"];
	if ($count == 0) {
		$messages[] = "No photos matched.";
	}
	else {
		$messages[] = "Your search matched $count image(s).";
	}
	
	// assign the necessary values to the page we display later on
	$smarty->assign('table', $strCbrTable);
	$smarty->assign('messages', $messages);
	$smarty->assign('images', $matchedImages);
	
	$smarty->assign('id', $id);

	$previous = $skip - $numberOfPhotosOnPage;
	$smarty->assign('previous', $previous);
	
	$next = $numberOfPhotosOnPage + $skip;
	if ($next > $count)
		$next = 0;
	$smarty->assign('next', $next);

	$smarty->assign('numberOfPhotosOnPage', $numberOfPhotosOnPage);
	$smarty->assign('count', $count);

	$smarty->assign('color', $color);
	$smarty->assign('shape', $shape);
	$smarty->assign('location', $location);
	$smarty->assign('texture', $texture);
	$smarty->assign('threshold', $threshold);

	$smarty->assign('self', $_SERVER['PHP_SELF']);
	
	// display the completed page
	$smarty->display('cbr.tpl');

?>