<?php
	require_once("includes/header.inc");
	
	// check if the necessary tables exist, otherwise create them
	prepareTextsTable($db);

	$arr = array();
	$header = array();
	$oldQuery = "";
	
	// check if this is a post request
	if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		$submitValue = $_POST['submit'];
		
		// check if the user hit the "Show all" button or the actual
		// query button
		if (strcasecmp($submitValue, 'Show all records') == 0) {
			$sql = "SELECT * FROM christie";
			
			executeQuery($db, $sql, $header, $arr);
		} else {			
			if (strlen($_POST['query']) > 0) {
				// construct the contains query
				// todo: prevent sql injection
				$sql = "SELECT id, SCORE(1) score, title FROM christie WHERE CONTAINS(title, '";
				$sql .= $_POST['query'];
				$sql .= "', 1) > 0 ORDER BY score DESC";
				
				executeQuery($db, $sql, $header, $arr);
				
				$oldQuery = $_POST['query'];
			} else {
				// do nothing
			}
		}
	}

	// if there are no images in the database we will print a
	// message to let the user know
	if (count($arr) == 0) {
		$messages[] = "No records matched.";
	}

	// assign the necessary values to the page we display later on
	$smarty->assign('messages', $messages);
	$smarty->assign('header', $header);
	$smarty->assign('texts', $arr);
	$smarty->assign('oldQuery', $oldQuery);
	$smarty->assign('self', $_SERVER['PHP_SELF']);
	
	// display the completed page
	$smarty->display('texts.tpl');
?>